    001/* ===========================================================
    002 * Orson Charts : a 3D chart library for the Java(tm) platform
    003 * ===========================================================
    004 *
    005 * (C)opyright 2013-2022, by David Gilbert.  All rights reserved.
    006 *
    007 * https://github.com/jfree/orson-charts
    008 *
    009 * This program is free software: you can redistribute it and/or modify
    010 * it under the terms of the GNU General Public License as published by
    011 * the Free Software Foundation, either version 3 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This program is distributed in the hope that it will be useful,
    015 * but WITHOUT ANY WARRANTY; without even the implied warranty of
    016 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    017 * GNU General Public License for more details.
    018 *
    019 * You should have received a copy of the GNU General Public License
    020 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
    021 *
    022 * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    023 * Other names may be trademarks of their respective owners.]
    024 *
    025 * If you do not wish to be bound by the terms of the GPL, an alternative
    026 * commercial license can be purchased.  For details, please see visit the
    027 * Orson Charts home page:
    028 *
    029 * http://www.object-refinery.com/orsoncharts/index.html
    030 *
    031 */
    032
    033package org.jfree.chart3d.renderer.category;
    034
    035import java.awt.Color;
    036
    037/**
    038 * A color source that can supply the colors for category plots.  This is the
    039 * interface through which the renderer will obtain colors for each data item
    040 * in the chart.  A default implementation
    041 * ({@link StandardCategoryColorSource}) is provided and you can customise
    042 * the rendering colors by providing an alternate implementation.
    043 */
    044public interface CategoryColorSource {
    045
    046    /**
    047     * Returns the color for one data item in the chart.  We return a
    048     * {@code Color} rather than a paint, because some manipulations
    049     * are done for the shading during the 3D rendering.
    050     *
    051     * @param series  the series index.
    052     * @param row  the row index.
    053     * @param column  the column index.
    054     *
    055     * @return The color.
    056     */
    057    Color getColor(int series, int row, int column);
    058
    059    /**
    060     * Returns the color to be used in the legend to represent the specified
    061     * series.
    062     *
    063     * @param series  the series index.
    064     *
    065     * @return The color.
    066     */
    067    Color getLegendColor(int series);
    068
    069    /**
    070     * Restyles the source using the specified colors.  Refer to the
    071     * implementing class to confirm the precise behaviour (typically all
    072     * existing color settings are cleared and the specified colors are
    073     * installed as the new defaults).
    074     *
    075     * @param colors  the colors.
    076     *
    077     * @since 1.2
    078     */
    079    void style(Color... colors);
    080
    081}
    082